package com.plannaplan.controllers;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@RunWith(SpringRunner.class)
@SpringBootTest
@ContextConfiguration
public class CoursesControllerTest {

    private static final String COURSES_ENDPOINT = "/api/v1/courses/getCourses";
    private static final String COURSESGROUPS_ENDPOINT = "/api/v1/courses/getCoursesWithGroups";

    @Autowired
    private WebApplicationContext webApplicationContext;

    @Test
    public void shouldReturnAllCoursesOk() throws Exception {

        MockMvc mockMvc = MockMvcBuilders.webAppContextSetup(webApplicationContext).build();
        mockMvc.perform(get(COURSES_ENDPOINT)).andExpect(status().isOk());
    }

    @Test
    public void shouldReturnAllCoursesWithGroupsOk() throws Exception {

        MockMvc mockMvc = MockMvcBuilders.webAppContextSetup(webApplicationContext).build();
        mockMvc.perform(get(COURSESGROUPS_ENDPOINT)).andExpect(status().isOk());
    }

}
